Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Interface XPathContext

All Known Implementing Classes:
  EarlyEvaluationContext, XPathContextMajor, XPathContextMinor

    public interface XPathContext

This class represents a context in which an XPath expression is evaluated.

Method Summary
`void` | `changeOutputDestination(Properties props, Result result, boolean isFinal, int hostLanguage, int validation, SchemaType schemaType)` Set a new output destination, supplying the output format details.
`ValueRepresentation` | `evaluateLocalVariable(int slotnumber)` Get the value of a local variable, identified by its slot number
`XPathContext` | `getCaller()` Get the calling XPathContext (the next one down the stack).
`StringCollator` | `getCollation(String name)` Get a named collation
`Configuration` | `getConfiguration()` Get the Configuration
`Item` | `getContextItem()` Get the context item
`int` | `getContextPosition()` Get the context position (the position of the context item)
`Controller` | `getController()` Get the Controller.
`GroupIterator` | `getCurrentGroupIterator()` Get the current group iterator.
`SequenceIterator` | `getCurrentIterator()` Get the current iterator.
`Mode` | `getCurrentMode()` Get the current mode.
`RegexIterator` | `getCurrentRegexIterator()` Get the current regex iterator.
`Rule` | `getCurrentTemplateRule()` Get the current template rule.
`StringCollator` | `getDefaultCollation()` Get the default collation
`int` | `getLast()` Get the context size (the position of the last item in the current node list)
`ParameterSet` | `getLocalParameters()` Get the local (non-tunnel) parameters that were passed to the current function or template
`NamePool` | `getNamePool()` Get the Name Pool
`InstructionInfoProvider` | `getOrigin()` Get information about the creating expression or other construct.
`int` | `getOriginatingConstructType()` Get the type of location from which this context was created.
`SequenceReceiver` | `getReceiver()` Get the Receiver to which output is currently being written.
`StackFrame` | `getStackFrame()` Get a reference to the local stack frame for variables.
`ParameterSet` | `getTunnelParameters()` Get the tunnel parameters that were passed to the current function or template.
`net.sf.saxon.expr.XPathContextMajor.XSLTContext` | `getXSLTContext()` Get the XSLT-specific part of the context
`boolean` | `isAtLast()` Determine whether the context position is the same as the context size that is, whether position()=last()
`XPathContextMajor` | `newCleanContext()` Construct a new context without copying (used for the context in a function call)
`XPathContextMajor` | `newContext()` Construct a new context as a copy of another.
`XPathContextMinor` | `newMinorContext()` Construct a new minor context.
`void` | `setCaller(XPathContext caller)` Set the calling XPathContext
`void` | `setCurrentIterator(SequenceIterator iter)` Set a new sequence iterator.
`void` | `setLocalVariable(int slotnumber, ValueRepresentation value)` Set the value of a local variable, identified by its slot number
`void` | `setOrigin(InstructionInfoProvider expr)` Set the creating expression (for use in diagnostics).
`void` | `setOriginatingConstructType(int loc)` Set the type of creating expression (for use in diagnostics).
`void` | `setReceiver(SequenceReceiver receiver)` Change the Receiver to which output is written
`void` | `setTemporaryReceiver(SequenceReceiver out)` Set the receiver to which output is to be written, marking it as a temporary (non-final) output destination.
`boolean` | `useLocalParameter(int fingerprint, LocalParam binding, boolean isTunnel)` Use local parameter.

Method Detail

### newContext

    XPathContextMajor newContext()

  Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context

### newCleanContext

    XPathContextMajor newCleanContext()

  Construct a new context without copying (used for the context in a function call)

### newMinorContext

    XPathContextMinor newMinorContext()

  Construct a new minor context. A minor context can only hold new values of the focus (currentIterator) and current output destination.

### getXSLTContext

    net.sf.saxon.expr.XPathContextMajor.XSLTContext getXSLTContext()

  Get the XSLT-specific part of the context

### getLocalParameters

    ParameterSet getLocalParameters()

  Get the local (non-tunnel) parameters that were passed to the current function or template

  Returns:
    a ParameterSet containing the local parameters

### getTunnelParameters

    ParameterSet getTunnelParameters()

  Get the tunnel parameters that were passed to the current function or template. This includes all active tunnel parameters whether the current template uses them or not.

  Returns:
    a ParameterSet containing the tunnel parameters

### setOrigin

    void setOrigin(InstructionInfoProvider expr)

  Set the creating expression (for use in diagnostics). The origin is generally set to "this" by the object that creates the new context. It's up to the debugger to determine whether this information is useful. Where possible, the object will be an `InstructionInfoProvider`, allowing information about the calling instruction to be obtained.

### setOriginatingConstructType

    void setOriginatingConstructType(int loc)

  Set the type of creating expression (for use in diagnostics). When a new context is created, either this method or `setOrigin(net.sf.saxon.trace.InstructionInfoProvider)` should be called.

  Parameters:
    `loc` - The originating location: the argument must be one of the integer constants in class `Location`

### getOrigin

    InstructionInfoProvider getOrigin()

  Get information about the creating expression or other construct.

### getOriginatingConstructType

    int getOriginatingConstructType()

  Get the type of location from which this context was created.

### getController

    Controller getController()

  Get the Controller. May return null when running outside XSLT or XQuery

### getConfiguration

    Configuration getConfiguration()

  Get the Configuration

### getNamePool

    NamePool getNamePool()

  Get the Name Pool

### setCaller

    void setCaller(XPathContext caller)

  Set the calling XPathContext

### getCaller

    XPathContext getCaller()

  Get the calling XPathContext (the next one down the stack). This will be null if unknown, or if the bottom of the stack has been reached.

### setCurrentIterator

    void setCurrentIterator(SequenceIterator iter)

  Set a new sequence iterator.

### getCurrentIterator

    SequenceIterator getCurrentIterator()

  Get the current iterator. This encapsulates the context item, context position, and context size.

  Returns:
    the current iterator, or null if there is no current iterator (which means the context item, position, and size are undefined).

### getContextPosition

    int getContextPosition()
                           throws DynamicError

  Get the context position (the position of the context item)

  Returns:
    the context position (starting at one)
  Throws:
    `DynamicError` - if the context position is undefined

### getContextItem

    Item getContextItem()

  Get the context item

  Returns:
    the context item, or null if the context item is undefined

### getLast

    int getLast()
                throws XPathException

  Get the context size (the position of the last item in the current node list)

  Returns:
    the context size
  Throws:
    `XPathException` - if the context position is undefined

### isAtLast

    boolean isAtLast()
                     throws XPathException

  Determine whether the context position is the same as the context size that is, whether position()=last()

  Throws:
    `XPathException`

### getCollation

    StringCollator getCollation(String name)
                                throws XPathException

  Get a named collation

  Throws:
    `XPathException` - if the collation is not recognized

### getDefaultCollation

    StringCollator getDefaultCollation()

  Get the default collation

### useLocalParameter

    boolean useLocalParameter(int fingerprint,
                              LocalParam binding,
                              boolean isTunnel)
                              throws XPathException

  Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated

  Parameters:
    `fingerprint` - The fingerprint of the parameter name
    `binding` - The XSLParam element to bind its value to
    `isTunnel` - True if a tunnel parameter is required, else false
  Returns:
    true if a parameter of this name was supplied, false if not
  Throws:
    `XPathException`

### getStackFrame

    StackFrame getStackFrame()

  Get a reference to the local stack frame for variables. Note that it's the caller's job to make a local copy of this. This is used for creating a Closure containing a retained copy of the variables for delayed evaluation.

  Returns:
    array of variables.

### evaluateLocalVariable

    ValueRepresentation evaluateLocalVariable(int slotnumber)

  Get the value of a local variable, identified by its slot number

### setLocalVariable

    void setLocalVariable(int slotnumber,
                          ValueRepresentation value)

  Set the value of a local variable, identified by its slot number

### changeOutputDestination

    void changeOutputDestination(Properties props,
                                 Result result,
                                 boolean isFinal,
                                 int hostLanguage,
                                 int validation,
                                 SchemaType schemaType)
                                 throws XPathException

  Set a new output destination, supplying the output format details.
  Note that it is the caller's responsibility to close the Writer after use.

  Parameters:
    `props` - properties defining the output format
    `result` - Details of the new output destination
    `isFinal` - true if the destination is a final result tree (either the principal output or a secondary result tree); false if not
    `hostLanguage` - typically XSLT or XQuery
    `validation` - validation mode: strict, lax, preserve, or strip
    `schemaType` - type against which the output must be validated
  Throws:
    `XPathException` - if any dynamic error occurs; and specifically, if an attempt is made to switch to a final output destination while writing a temporary tree or sequence

### setTemporaryReceiver

    void setTemporaryReceiver(SequenceReceiver out)

  Set the receiver to which output is to be written, marking it as a temporary (non-final) output destination.

  Parameters:
    `out` - The SequenceOutputter to be used

### setReceiver

    void setReceiver(SequenceReceiver receiver)

  Change the Receiver to which output is written

### getReceiver

    SequenceReceiver getReceiver()

  Get the Receiver to which output is currently being written.

  Returns:
    the current Receiver

### getCurrentMode

    Mode getCurrentMode()

  Get the current mode.

  Returns:
    the current mode

### getCurrentTemplateRule

    Rule getCurrentTemplateRule()

  Get the current template rule. This is used to support xsl:apply-imports and xsl:next-match

  Returns:
    the current template rule

### getCurrentGroupIterator

    GroupIterator getCurrentGroupIterator()

  Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0

  Returns:
    the current grouped collection

### getCurrentRegexIterator

    RegexIterator getCurrentRegexIterator()

  Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.

  Returns:
    the current regular expressions iterator

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.